/*Questo file contiene funzioni e procedure su alberi binari*/

#include "alberinari.h"

/*Pre: l'albero che si costruisce e' NON vuoto*/
/*Post: costruisce in preordine un albero n-ario*/


ALBERONARIO creaalbero()
{

	ALBERONARIO T, temp;
	int i,j,k;

	scanf("%d %d",&i,&j);
	T=malloc(sizeof(TREENODEN));
	if (T==NULL)
		printf("memoria non allocata\n");
	else
	{
		T->elem=i;
		T->fratello=NULL;
		if (j==0)
	        {
			T->primofiglio=NULL;
                }
		else 
			T->primofiglio=creaalbero();
		temp=T->primofiglio;
		for (k=0;k<j-1;k++)
		{
		/*	printf("entrato nel ciclo con i pari a %d\n",i);*/
			temp->fratello=creaalbero();
			/*printf("valore mio e del fratello %d %d\n",temp->elem, temp->fratello->elem);*/
			temp=temp->fratello;
		}
	}
	return T;
}


/*Post:Restituisce 1 se l'albero e' vuoto, 0 altrimenti*/

int alberonvuoto(ALBERONARIO T)
{
	return(T==NULL);
}

/*Post: stampa in preorder (prima la radice quindi il primo dei suoi sottoalberi,
quindi il secondo dei suoi sottoalberi etc... i valori contenuti nei nodi dell'albero*/

void stampapreordinealberon(ALBERONARIO T)
{
	ALBERONARIO temp;
	if (T!=NULL)
	{
		printf("%d\n",T->elem);
		temp=T->primofiglio;
		while (temp!=NULL)
	        {
			stampapreordinealberon(temp);
			temp=temp->fratello;
        	}
	}
	return;
}

/* Pre: albero non vuoto
Post: restituisce il valore massimo contenuto nell'albero */
int maxalberon(ALBERONARIO T)
{
	ALBERONARIO temp=T->primofiglio;
        int massimo = T->elem;
	int currmax;

        while (temp!=NULL)
        {
                currmax=maxalberon(temp);
		if (currmax>massimo)
			massimo=currmax;
		temp=temp->fratello;
        }
        return massimo;
}

/*Post: restituisce i se il valore x e' contenuto nell'albero, 0 altrimenti */
int findalberon(ALBERONARIO T, int x)
{
        ALBERONARIO temp;
        int trovato;
        
        if (T==NULL)
		return 0;
	if (T->elem==x)
		return 1;
	temp=T->primofiglio;
	trovato=0;                                                                                                                            
        while ((temp!=NULL)&& !trovato)
        {
                if (findalberon(temp,x))
			trovato=1;
		temp=temp->fratello;
        }
        return trovato;
}


