/* nome di questo file: OpAlbGen, contiene le definizioni delle funzioni essenziali 
per la gestione di una collezione, quando i dati sono 
memorizzati in un albero binario di ricerca*/

/*Invariante dell'implementazione di una collezione:
gli elementi sono memorizzati  in un Albero Binario di Ricerca */

/* keyComp( void *a, void *b ) restituisce -1, 0, 1 se,rispettivamente
 a < b, a == b, a > b 
 */

#include "specColl.h"


/* delMin  una funzione ausiliaria per remEl */



void* delMin( CollPtr *t );
/* cancella il nodo minimo (il nodo senza figli sinistri alla fine del cammino
* che parte  dalla radice e che usa solo archi padre-figlio sinistro)
* e ne restituisce il valore 
*prec (t != NULL)
postc: restituisce il minimo valore  e  cancella quel nodo da t */ 



 void* delMin( CollPtr *t )
/* cancella il nodo minimo e ne restituisce il valore 
*prec (t != NULL)
postc: restituisce il minimo valore  e  cancella quel nodo da t */ 
{void* app;
 CollPtr tempPtr;
assert(*t != NULL);
if ((*t) -> lPtr == NULL) /* ho trovato il  minimo */
{app = (*t) ->elem;
 tempPtr = *t; 
*t = (*t) -> rPtr; 
free(tempPtr);
 return app;}
else
return delMin( &((*t) ->lPtr) ); 
}
 
CollPtr inizColl(void)
/* inizializza la collezione, restituendo un puntatore a una collezione vuota.
 *postc: restituisce un puntatore di valore NULL. 
*/
{return NULL;}


void distrColl(CollPtr tPtr)
/*libera la memoria occupata dalla collezione */

{
if (tPtr)  distrColl(tPtr ->lPtr);
if (tPtr)  distrColl(tPtr ->rPtr);
free(tPtr);
}


CollPtr cerca(CollPtr t, void *key,int keyComp() )
/*postc: restituisce un puntatore a key  in t
*se presente, NULL altrimenti (anche quando la collezione  vuota) */

{if ( t != NULL ) 
  {  if ( keyComp(key,t->elem) == 0 )  return t;
     else 
       if ( keyComp(key,t->elem) == -1 )/* Pi piccolo, cerca a sinistra */
     return cerca(t->lPtr, key,keyComp ); 
          else   /* Pi grande, cerca a destra */ 
     return cerca(t->rPtr, key,keyComp );}
else 
return NULL;
} 

CollPtr addElem( CollPtr t, CollPtr new ,int keyComp()) 
/* "versione funzionale".
 Aggiunge l'elemento el alla collezione t, se non gia' presente
 *postc: restituisce t con l'aggiunta di el, se non gia' presente, 
 la collezione immutata altrimenti */
{if ( t == NULL ) /* Se lalbero  vuoto il nuovo nodo e' la radice */
       return new; 
     if (keyComp( new->elem, t->elem ) == -1)/* Pi piccolo, inserimento a sinistra */
t->lPtr = addElem(t->lPtr,new,keyComp ); 
else if (keyComp( new->elem, t->elem ) == 1)  /* Pi grande, inserimento a destra */
t->rPtr = addElem(t->rPtr, new,keyComp );
else return t; 
return t;}
   
CollPtr addElRip( CollPtr t, CollPtr new ,int keyComp()) 
/*"versione funzionale"
postc:  new e' inserito nel posto giusto nella collezione t, 
senza ripetizioni
*/
{if ( t == NULL ) /* Se lalbero  vuoto il nuovo nodo e' la radice */
       return new; 
if (keyComp( new->elem, t->elem ) == -1)/* Pi piccolo, inserimento a sinistra */
	t->lPtr = addElRip(t->lPtr,new,keyComp ); 
else   /* Pi grande o uguale, inserimento a destra */
	t->rPtr = addElRip(t->rPtr, new,keyComp );
return t;}
   

int remEl( CollPtr *t,void* val,int keyComp()  )
/* cancella la prima occorrenza di val nella collezione t
*prec: (*t != NULL)
postc: restituisce 1 se ha trovato e 
cancellato l'elemento, 0 altrimenti */

{ CollPtr  tempPtr;
assert(*t!=NULL);
 if (keyComp(val,(*t) ->elem) == 0) 
    {if ((*t)-> lPtr == NULL ) 
    {tempPtr = *t;(*t) = (*t) ->rPtr; free(tempPtr);}
 	 else 
        if ((*t) -> rPtr == NULL) 
    	{ tempPtr = *t;(*t) = (*t) ->lPtr; free(tempPtr);}
        else /* ha due figli */
         (*t)-> elem = delMin(&((*t) ->rPtr));
         return 1;}
else  if (keyComp(val,(*t) ->elem) < 0 ) 
          if  ((*t) -> lPtr != NULL)  return remEl(&(*t) -> lPtr,val,keyComp);
          else return 0;
      /* qui (val > tempPtr ->info) */ 
      else if ((*t) -> rPtr!= NULL)   return remEl(&(*t) -> rPtr,val,keyComp); 
           else return 0;
            }
