/*nome file: OpListaOrd.c 
*Invariante dell'implementazione della collezione su liste ordinate:
*gli elementi sono memorizzati nella lista in modo che 
*keyComp(x,y)  sia  -1 o 0 (cio x sia minore o uguale di y) per due elemementi x e y 
*in nodi successivi nella lista. */

#include "specColl.h"


CollPtr inizColl(void)
/* inizializza la collezione, restituendo un puntatore a una collezione vuota.
postc: restituisce NULL 
*/
{return NULL;}

void distrColl(CollPtr L)
/* libera la memoria occupata dalla collezione C */
{if (L)  distrColl(L->nextPtr);
free(L);}

CollPtr  creaElem(void* val)
/* crea un elemento che contiene val
postc: restituisce un puntatore a un elemento che contiene val*/

{ CollPtr elPtr;
elPtr = calloc(1,sizeof(Nodo));
if (elPtr != NULL)
   {elPtr->elem = val;
    return elPtr;
   }
   else {fprintf(stderr,"non c'e' abbastanza memoria per creaElem, valore non inserito \n");
return NULL;}
 }



CollPtr cerca(CollPtr L, void * el, int keyComp())
/*postc: restituisce un puntatore alla prima occorrenza di el in L
*se presente, NULL altrimenti (anche quando la collezione  vuota)  */

{if (!L) return NULL;
if (keyComp(L->elem,el) == 0) return L;
 if (keyComp(L->elem,el) == -1)
		return cerca(L->nextPtr, el,keyComp);
	else return NULL;
}

CollPtr addElem( CollPtr L, CollPtr new ,int keyComp())
/* "versione funzionale".
 Aggiunge l'elememento new alla collezione L, se non gia' presente
 *postc: restituisce L con l'aggiunta di new, se non gia' presente, 
 la collezione immutata altrimenti */ 
	
{if (!L) return new;
if (keyComp(L->elem,new -> elem) == +1) /* L->elem > new ->elem, devo inserire */
		{new -> nextPtr = L;
		return new;}
if (keyComp(L->elem, new -> elem) == -1)  /* L->elemem < elem */
	L->nextPtr = addElem(L->nextPtr, new,keyComp); /* cerca il punto di inserimento */
return L; /* L->elem = new -> elem, non devo inserire */
}



CollPtr addElRip( CollPtr L, CollPtr new ,int keyComp())
/* "versione funzionale".
 Aggiunge l'elememento new alla collezione L con eventuali ripetizioni
 *postc: restituisce L con l'aggiunta di new  */
	
{if (!L) return new;
if (keyComp(L->elem,new -> elem) == -1)  /* L->elemem < elem */
	 L->nextPtr = addElRip(L->nextPtr, new,keyComp); /* cerca il punto di inserimento */
else /* L->elem >= el */
		{new-> nextPtr = L;
		return new;}
return L;}



							
int  remEl(CollPtr *L, void* el ,int keyComp())
/* cancella la prima occorrenza di el  nella collezione L 
 *prec: (*L
  != NULL)
* postc: restituisce 1 se ha trovato e cancellato l'elememento,0 altrimenti */
{ CollPtr M;
if (keyComp((*L)->elem,el)==0) 
		{ M = (*L);
		(*L) = (*L)->nextPtr;
		free(M);
		return 1;}
if (keyComp((*L)->elem,el) == -1)	
	if ((*L)->nextPtr)  remEl(&((*L)->nextPtr), el,keyComp);
	else 
	return 0; /* si  raggiunta la fine della lista e l'elememento non  stato trovato*/
else 
return 0; /* (*L)->elem > el quindi l'elememento non  presente */
}  

