/*Esercizio 1.  Si definisca la funzione C

*int cont(TreePtr t);
*che restituisce il numero dei nodi contenti, 
*cio dei nodi il cui sottoalbero contiene pi figli sinistri che destri. 
*Un  nodo di un albero binario  un figlio sinistro 
*se  il figlio sinistro di suo padre, e simmetricamente per figlio destro.*/

/*Una soluzione accettabile, ma inefficiente, consiste nel chiamare
*su ogni nodo due funzioni ausiliarie che restituiscono il 
*numero dei figli sinistri rispettivamente quello dei destri, 
*confrontare i due risultati e incrementare il valore restituito
*nel caso che il confronto dica che il nodo e' contento.
*Volendo una soluzione in cui si visiti l'albero una sola volta, si devono
*usare dei parametri per ricordare i dati che servono.
*Si possono usare  due parametri: uno per ricordare 
*la differenza tra il numero dei figli sinistri 
*e quello dei destri  e uno per il numero di nodi contenti.
*Poich la differenza tra il numero dei figli sinistri 
*e quello dei destri deve essere valutata per ogni sottoalbero, allora
* deve essere un parametro locale, azzerato sulle foglie e aggiornato
*all'uscita da ogni chiamata.
*Il numero dei nodi contenti invece deve essere un parametro 
*il cui valore e' preservato attraverso le varie chiamate e opportunamente 
*aggiornato. Scegliamo di definire una funzione ausiliaria, contAus,
* che restituisce  la differenza tra il numero dei figli sinistri 
*e quello dei destri, e che prende come parametro un puntatore a un intero
* nel quale restituire il risultato.*/



int cont(TreePtr t)
/*postc: restituisce il numero dei nodi contenti in t*/
{int m=0;
contAus(t,&m);return m;}  /* il risultato voluto e' nel parametro m!*/

int contAus(TreePtr t,int *ris)
/*prec: *ris = 0;
postc: restituisce il numero dei nodi contenti in t*/
{int diff1,diff2;
if (!t)  return 0;
if  (!t->lPtr && !t->rPtr)  return 0; /*qui inizializziamo diffi,per i = 1 o 2*/
if (t->lPtr) {diff1 = contAus(t->lPtr,ris);
			   diff1++; 
			  } else diff1 = 0;
if (t->rPtr) {diff2 = contAus(t->rPtr,ris);
			 diff2++; 
 			 } else diff2 = 0;
if (diff1-diff2 > 0) (*ris)++; /*il tal caso t e' contento*/
return (diff1 + diff2); 
/* la differenza alla radice e' la somma delle differenze
nei sottoalberi */
}

/*Esercizio  2. Si definisca la funzione C

*int MaxP(NTreePtr t);
 
*che dato un albero n-ario di interi i cui nodi hanno valore 0 o 1,  
*calcola la lunghezza del pi lungo cammino dalla radice a un nodo con valore 1.

*Abbiamo bisogno di calcolare il livello di un nodo e di ricordarci quello del
*piu' lontano dalla radice con valore 1 finora trovato.
*Scegliamo di utilizzare un parametro per calcolare il livello (o profondita') di ogni nodo
e di restituire come valore della funzione il livello massimo fino a quel momento calcolato*/

int MaxP(ALBERONARIO t)
/*postc: restituisce la lunghezza del pi lungo cammino dalla radice a un nodo con valore 1.*/
{return MaxPAus(t,0);}


int MaxPAus(ALBERONARIO t, int p)
/*prec: p = 0;
postc: restituisce la lunghezza del pi lungo cammino dalla radice a un nodo con valore 1.*/
{int ris,app;
if (!t) return 0;
ris = MaxPAus(t-> primofiglio,p+1); 
if (t && t-> elem == 1) ris = max(p,ris);
app = MaxPAus(t-> fratello,p);
if (t && t-> elem == 1)   app=max(app,p); 
return max(ris,app);}

