/*Esercizio. Si definisca la funzione C
*int ABR(TreePtr t);
 *che dato un albero binario di interi verifica se e' di ricerca. 

Nota: Poiche' sui lucidi forniti a lezione compariva una definizione di albero binario di ricerca
*che faceva riferimento ai figli di un nodo anziche' ai nodi 
*nei sottoalberi radicati nei figli, le soluzioni che implementavano
*correttamente questa definizione sono state valutate positivamente. 
* Ma la definizione corretta, nel caso senza ripetizioni, e' la seguente: 
*Un albero binario etichettato e' un albero binario di ricerca se
*per ogni nodo N,  le etichette dei nodi nel sottoalbero sinistro di N sono minori 
*di quella di N e  quelle dei nodi nel
*sottoalbero destro sono maggiori di quella di N.

/*Soluzione. 
*Le etichette sono elementi in un insieme totalmente ordinato, per esempio gli interi.
*Osserviamo che se T  un albero binario di 
*ricerca in cui le informazioni contenute nei nodi sono interi 
*tutti distinti tra loro allora, per definizione di albero di ricerca, 
*una visita simmetrica (inorder) di T deve restituire una sequenza 
*crescente di interi. Potremmo quindi adattare la funzione di visita inorder
*in modo che ogni nodo visitato venga inserito in una lista, e poi controllando
* che la lista ottenuta sia crescente.
*Si pu migliorare questa soluzine evitando l'utilizzo di una lista e usando una funzione ausiliaria con
* un parametro variabile di tipo intero in cui salvare l'ultimo visitato in modo da poter confrontare 
*a due a due gli elementi nell'albero nell'ordine determinato dalla visita inorder.
*Se il precedente  sempre minore del nodo correntemente visitato, l'albero  un albero binario di ricerca.
La funzione inizialmente  chiamata con il pi piccolo intero rappresentabile come precedente.*/
 
int ABRaus (TreePtr tPtr, int *prec)
/* preC: prec contiene un intero pi piccolo di ogni intero in tPtr.
*postC: restituisce 1 se tPtr punta alla radice di un albero binario di ricerca,
senza ripetizioni, 0 altrimenti*/
{int ris;
if (!tPtr) return 1;
ris = ABRaus(tPtr->lPtr,prec);
ris = ris && *prec < tPtr->elem;
*prec = tPtr->elem;
ris = ris && ABRaus(tPtr->rPtr,prec);
 return ris;} 
 
int ABR(TreePtr tPtr)
/* postC: restituisce 1 se tPtr punta alla radice di un albero binario di ricerca,
senza ripetizioni, 0 altrimenti*/
{int m = INT_MIN;
return ABRaus(tPtr,&m);}


/*Esercizio. Si definisca la funzione C
*void CFU(TreePtr *t);
* una funzione che cancella i nodi di dell'albero binario (di interi) in input  con un unico figlio.*/
void CFU(TreePtr *t)
/*postc: restituisce *t privato dei nodi con un solo figlio*/
{ if (!*t) return;
if ((*t) -> lPtr && !(*t) -> rPtr) *t = (*t) -> lPtr;
if ((*t) -> rPtr && !(*t) -> lPtr) *t = (*t) -> rPtr; 
CFU(&(*t) -> lPtr);
CFU(&(*t) -> rPtr);
}
