/* nome di questo file: specColl.h, contiene i prototipi delle funzioni essenziali
per gestire una collezione */

#include "dichColl.h"

/* KeyCmp( void *a, void *b ) restituisce -1, 0, 1 se,rispettivamente
 a < b, a == b, a > b */

CollPtr inizColl(void);
/* inizializza la collezione, restituendo un puntatore a una collezione vuota.
postc: restituisce NULL 
*/

void distrColl(CollPtr C);
/* libera la memoria occupata dalla collezione C */


CollPtr cerca(CollPtr C, void * el, int keyComp());
/*postc: restituisce un puntatore a el  in C
*se presente, NULL altrimenti (anche quando la collezione  vuota) */



CollPtr addElem( CollPtr C, CollPtr el ,int keyComp());
/* "versione funzionale".
 Aggiunge l'elemento el alla collezione C, se non gia' presente
 *postc: restituisce C con l'aggiunta di el, se non gia' presente, 
 la collezione immutata altrimenti */



CollPtr addElRip(CollPtr C ,CollPtr el ,int keyComp());
/* Aggiunge l'elemento passato come secondo argomento
 alla collezione C
 *postc: restituisce la collezione C
 con l'aggiunta dell'elemento el , la collezione immutata 
 altrimenti */

int  remEl(CollPtr *C, void* el ,int keyComp());
/* cancella la prima occorrenza di el  nella collezione C 
 *prec: (*t != NULL)
* postc: restituisce 1 se ha trovato e cancellato l'elemento, 0 altrimenti */
